/**
 * Translator Revolution DropDown WP Plugin
 * http://goo.gl/xrxDo
 *
 * LICENSE
 *
 * You need to buy a license if you want use this script.
 * http://codecanyon.net/legal/market
 *
 * @package    Translator Revolution WP Plugin
 * @copyright  Copyright (c) 2015, SurStudio, www.surstudio.net
 * @license    http://codecanyon.net/licenses/standard
 * @version    1.4.1
 * @date       2015-07-10
 * 
 * If this file is modified, then it's recommended to compress it to speed up the loading times.
 * This file has been compressed using the http://javascriptcompressor.com/ online compressor with
 * "Base62 encode" and "Shrink variables" options enabled, and placed it in the translator/_javascript/
 * folder
 */

jQuery.fn.extend({

	translator: function(_options) {

		return this.each(function() {

			new jQuery.Translator(this, _options);

		});

	}

});

jQuery.Translator = function(_container, _options) {

	var undefined;

	this._options = null;
	this._container = null;
	this._last_selected = null;
	this._links = null;
	this._restore = null;

	this._initialize = function(_container, _options) {
		
		this._initialize_options(_options);
		this._initialize_elements(_container);
		
		if (this._is_compatible()) {
			this._adjust_html();
			this._on_initialize();
			this._initialize_events();
		}
		else {
			try {
				console.log("API Key missing, disabling translator...");
			}
			catch (e) {};
			this.disable();
		}
			
	};

	this.disable = function() {
		
		this._container.hide();
		
	};
	
	this._is_compatible = function() {
		
		return this._options.apiKey != "";
		
	};
	
	this._on_initialize = function() {
		
		if (typeof this._options.onInitialize == "function" || typeof this._options.onInitialize == "object")
			if (this._options.onInitialize.call)
				this._options.onInitialize();
		
	};
	
	this._adjust_html = function() {
	
		jQuery(document.getElementsByTagName("html")).css("margin-top", "20px");
		
	};
	
	this._initialize_options = function(_options) {
		
		this._options = jQuery.extend({}, _options);
		
		if (this._options.languages == undefined)
			this._options.languages = ["en", "es", "fr", "de", "da", "ja", "it", "pt"];
		
		if (!(this._options.languages instanceof Array))
			this._options.languages = [this._options.languages];

		if (this._options.flags == undefined || !this._is_bool(this._options.flags))
			this._options.flags = true;
			
		if (this._options.names == undefined || !this._is_bool(this._options.names))
			this._options.names = true;

		if (this._options.shortNames == undefined || !this._is_bool(this._options.shortNames))
			this._options.shortNames = false;

		if (this._options.targetSelector == undefined)
			this._options.targetSelector = "body";

		if (this._options.excludeSelector == undefined)
			this._options.excludeSelector = ".do-not-translate-me, .dont-translate";

		this._options.excludeSelector += ", .skiptranslate";

		if (this._options.cookie == undefined || !this._is_bool(this._options.cookie))
			this._options.cookie = true;

		if (this._options.cookiePersistency == undefined || !this._is_bool(this._options.cookiePersistency))
			this._options.cookiePersistency = true;

		if (this._options.requests == undefined || !Number(this._options.requests))
			this._options.requests = 25;
		else
			this._options.requests = Number(this._options.requests);

		if (this._options.id == undefined)
			this._options.id = "translator-jquery";
		else
			this._options.id.replace(/\s+/g, "-");

		if (this._options.from == undefined)
			this._options.from = "en";

		if (this._options.autoSelect == undefined || !this._is_bool(this._options.autoSelect))
			this._options.autoSelect = true;

		if (this._options.from == "")
			this._options.autoSelect = false;

		if (this._options.separator == undefined)
			this._options.separator = "";

		if (this._options.onStart == undefined)
			this._options.onStart = function(filtered_elements, source, from, to, options) {};

		if (this._options.onComplete == undefined)
			this._options.onComplete = function(filtered_elements, translation, source, from, to, options, restore) {};

		if (this._options.linksContainerTemplate == undefined)
			this._options.linksContainerTemplate = '<div class="{{ sub_container_class }}"><table border="0" cellspacing="0" cellpadding="0"><tbody><tr>{{ content }}</tr></tbody></table></div>';

		if (this._options.linkTemplate == undefined)
			this._options.linkTemplate = '<td><a href="javascript:;" title="{{ name }}" class="{{ language_selector_class }}">{{ content }}</a></td>';

		if (this._options.flagTemplate == undefined)
			this._options.flagTemplate = '<img src="{{ src }}" alt="{{ name }}" />';

		if (this._options.nameTemplate == undefined)
			this._options.nameTemplate = '<span>{{ name }}</span>';

		if (this._options.restore == undefined || !this._is_bool(this._options.restore))
			this._options.restore = true;

		if (this._options.restoreTo == undefined)
			this._options.restoreTo = "en";
			
		if (this._options.from == "" && this._options.restoreTo == "")
			this._options.restore = false;

		if (this._options.loading == undefined || !this._is_bool(this._options.loading))
			this._options.loading = true;

		if (this._options.complete == undefined || !this._is_bool(this._options.complete))
			this._options.complete = true;

		if (this._options.apiKey == undefined)
			this._options.apiKey = ""; // Sign up for one: http://www.bing.com/toolbox/bingdeveloper/
			
		if (this._options.from != "")
			this._options.restoreTo = this._options.from;

		if (this._options.restoreTemplate == undefined)
			this._options.restoreTemplate = '<div class="{{ hidden_class }} {{ restore_container_class }}"><a href="javascript:;" title="Restore" class="{{ restore_class }}">Restore</a></div>';

		if (this._options.flagsFolder == undefined)
			this._options.flagsFolder = "images/";

		/*
		 *	Style Classes 
		 */

		if (this._options.languageSelectorClass == undefined)
			this._options.languageSelectorClass = "translator-language-";

		if (this._options.customLanguageSelectorClass == undefined)
			this._options.customLanguageSelectorClass = "translator-custom-language-";

		if (this._options.flagsClass == undefined)
			this._options.flagsClass = "translator-flags";

		if (this._options.namesClass == undefined)
			this._options.namesClass = "translator-names";
		
		if (this._options.shortNamesClass == undefined)
			this._options.shortNamesClass = "translator-short-names";

		if (this._options.flagsAndNamesClass == undefined)
			this._options.flagsAndNamesClass = "translator-flags-and-names";

		if (this._options.flagsAndShortNamesClass == undefined)
			this._options.flagsAndShortNamesClass = "translator-flags-and-short-names";

		if (this._options.loadingClass == undefined)
			this._options.loadingClass = "translator-loading-left";

		if (this._options.completedClass == undefined)
			this._options.completedClass = "translator-completed-left";

		if (this._options.containerClass == undefined)
			this._options.containerClass = "translator-container";

		if (this._options.subContainerClass == undefined)
			this._options.subContainerClass = "translator-sub-container";			

		if (this._options.restoreClass == undefined)
			this._options.restoreClass = "translator-restore";

		if (this._options.restoreContainerClass == undefined)
			this._options.restoreContainerClass = "translator-restore-container";

		if (this._options.hiddenClass == undefined)			
			this._options.hiddenClass = "translator-hidden";
		
		if (typeof _options.override == "object")
			this._options = jQuery.extend(this._options, _options.override);
		
		this._options._languages = jQuery.extend({}, jQuery.translate().getLanguages());
			
		this._initialize_custom_languages();

		this._options._owner = this;

		this._sanitize_id();
		this._preload_images();

	};
	
	this._initialize_custom_languages = function() {

		if (typeof this._options.customLanguages != "object") 
			return;
		
		this._options._languages = jQuery.extend(this._options._languages, this._options.customLanguages);
		
	};
	
	this._preload_images = function() {
		
		var container = document.createElement("div");
		var sub_container;
			
		if (this._options.restore) {
			sub_container = document.createElement("div");
			sub_container.className = this._options.restoreClass;
			container.appendChild(sub_container);
		}

		if (this._options.loading) {
			sub_container = document.createElement("div");
			sub_container.className = this._options.loadingClass;
			container.appendChild(sub_container);
		}

		if (this._options.complete) {
			sub_container = document.createElement("div");
			sub_container.className = this._options.completedClass;
			container.appendChild(sub_container);
		}
		
		container.style.position = "absolute";
		container.style.left = "-5000px";
		container.style.top = "-5000px";
		
		document.body.appendChild(container);
		
	};
	
	this._sanitize_id = function() {
		
		for (var i=0; i<jQuery.translator.ids.length; i++) 
			if (this._options.id == jQuery.translator.ids[i])
				this._options.id += "-" + jQuery.translator.ids.length;
		
		jQuery.translator.ids.push(this._options.id);
		
	};
		
	this._initialize_elements = function(_container) {
		
		this._container = jQuery(_container);
		
		this._update_content();
	
		if (this._options.flags) {
			if (this._options.names) {
				if (this._options.shortNames)
					this._container.addClass(this._options.flagsAndShortNamesClass);
				else
					this._container.addClass(this._options.flagsAndNamesClass);
			}
			else
				this._container.addClass(this._options.flagsClass);
		} 
		else if (this._options.names) {
			if (this._options.shortNames)
				this._container.addClass(this._options.shortNamesClass);
			else
				this._container.addClass(this._options.namesClass);
		}
		
		this._options._container = this._container;
		
		this._links = this._container.find("[class*=" + this._options.languageSelectorClass + "]");
		for (var i=0; i<this._links.length; i++)
			this._links[i]._owner = this;
		
		this._restore = this._container.find("." + this._options.restoreClass);
		for (var i=0; i<this._restore.length; i++)
			this._restore[i]._owner = this;
		
	};

	this._update_content = function() {
	
		var links = this._container.find("[class*=" + this._options.languageSelectorClass + "]");
		var flag = true;
		var regex = new RegExp("\\b" + this._options.languageSelectorClass + "([a-zA-Z\-]{2,6})\\b");
		
		for (var i=0; i<links.length; i++)
			if (regex.exec(links[i].className))
				flag = false;
		
		if (links.length == 0 || (links.length > 0 && flag)) {
			this._container.html(this._gen_content());
			this._container.addClass(this._options.containerClass);
			this._container.addClass(this._options.id);
		}

	};
	
	this._initialize_events = function() {

		this._links.click(function() {

			if (jQuery.translator.lastT._is_translating())
				return;

			jQuery(this).blur();

			if (this._owner._last_selected && this._owner._last_selected.get(0) == this) {
				
				this._owner._do_restore();

				return;
			}

			this._owner._translate(this);

		});

		this._restore.click(function() {

			if (jQuery.translator.lastT._is_translating())
				return;

			this._owner._do_restore();

		});
	
		var flag = true;
	
		if (this._options.cookie) {
			
			var cookie_to = jQuery.cookie("translator-" + this._options.id + "-to");
			if (cookie_to != undefined) {

				var language = this._container.find("." + this._options.customLanguageSelectorClass + cookie_to);
				if (language.length > 0) {
					this._translate(language.get(0));
					flag = false;
				}
				else {
					
					language = this._container.find("." + this._options.languageSelectorClass + cookie_to);
					var regex = new RegExp("\\b" + this._options.customLanguageSelectorClass + ".*\\b");
					
					for (var i=0; i<language.length; i++) {
											
						var has_class = regex.exec(language.get(i).className);
						if (!has_class) {
							this._translate(language.get(i));
							flag = false;
							break;
						}
						
					}

				}

			}

		}

		if (flag && this._options.autoSelect && this._options.complete) {

			var language = this._container.find("." + this._options.languageSelectorClass + this._options.from);
			
			if (language.length > 0) {
				this._last_selected = jQuery(language.get(0));
				this._last_selected.addClass(this._options.completedClass);
			}

		}
		
	};
	
	this._do_restore = function() {

		this._show_restore(false);
		jQuery.cookie("translator-" + this._options.id + "-to", null, { path: "/" });
		
		var restore_to = this._options.from == "" ? this._options.restoreTo : this._options.from;

		var language = this._container.find("." + this._options.languageSelectorClass + restore_to);
		this._last_selected = jQuery(language.get(0));
	
		this._do_translate(restore_to, this._options, true);
		
	};
	
	this._should_translate = function(_element) {

		var language = this._extract_language(_element);
	
		if (this._last_selected) {
			if (this._extract_language(this._last_selected.get(0)) == language)
				return false;
		}
		else if (language == this._options.from)
			return false;	
			
		return true;
		
	};
	
	this._translate = function(_element) {

		var language = this._extract_language(_element);

		this._select(_element);

		if (this._options.cookie) {
			if (this._options.cookiePersistency)
				jQuery.cookie("translator-" + this._options.id + "-to", this._get_language_for_cookie(_element), { expires: 365, path: "/" });
			else
				jQuery.cookie("translator-" + this._options.id + "-to", this._get_language_for_cookie(_element), { path: "/" });
		}

		this._do_translate(language, this._options, false);
		
	};
	
	this._get_language_for_cookie = function(_element) {
		
		var regex = new RegExp("\\b" + this._options.customLanguageSelectorClass + ".*\\b");
		var has_class = regex.exec(_element.className);

		if (!has_class)
			return this._extract_language(_element);
		
		has_class = has_class[0].split(" ")[0];
		
		var result = has_class.replace(this._options.customLanguageSelectorClass, "");
		result = result.replace(/^\s*|\s*$/g, "");
		result = result.toLowerCase();
		
		return result;
		
	};
	
	this._extract_language = function(_element) {

		var regex = new RegExp("\\b" + this._options.languageSelectorClass + ".*\\b");
		var has_class = regex.exec(_element.className);

		if (!has_class)
			return;
		
		has_class = has_class[0].split(" ")[0];
		
		var result = has_class.replace(this._options.languageSelectorClass, "");
		result = result.replace(/^\s*|\s*$/g, "");
		result = result.toLowerCase();
		
		if (result == "zh-chs")
			result = "zh-CHS";
		else if (result == "zh-cht")
			result = "zh-CHT";
		
		return result;
		
	};
	
	this._do_translate = function(_language, _options, _restore) {

		jQuery(_options.targetSelector).translate({
			api_key: this._options.apiKey,
			from: _options.from,
			to: _language,
			toggle: true,
			data: true,
			not: jQuery.merge(jQuery(_options.excludeSelector), jQuery("." + _options.containerClass)),
			requests: this._options.requests,
			stripWhitespace: false,
			trim: false,
			start: function(_filtered_elements, _source, _from, _to, __options) { _options._owner._on_start(_filtered_elements, _source, _from, _to, __options); },
			complete: function(_filtered_elements, _translation, _source, _from, _to, __options) { _options._owner._on_complete(_restore, _filtered_elements, _translation, _source, _from, _to, __options); },
			error: function() { _options._owner._on_complete(_restore); }
		});
		
	};
	
	this._on_start = function(_filtered_elements, _source, _from, _to, __options) {

		this._show_restore(false);

		try {
			if (this._options.onStart)
				this._options.onStart(_filtered_elements, _source, _from, _to, __options);
		}
		catch(e) { }
		
	};
	
	this._on_complete = function(_restore, _filtered_elements, _translation, _source, _from, _to, __options) {
		
		this._clear_select(this._options);

		if (!_restore) {

			if (this._options.complete)
				this._last_selected.addClass(this._options.completedClass);
			
			if (this._extract_language(this._last_selected.get(0)) == _to)
				this._show_restore(true);
				
		}
		else
			if (this._options.complete && this._options.autoSelect)
				this._last_selected.addClass(this._options.completedClass);
		
		try {
			if (this._options.onComplete)
				this._options.onComplete(_filtered_elements, _translation, _source, _from, _to, __options, _restore);
		}
		catch(e) { }
		
	};
	
	this._select = function(_element) {
		
		this._last_selected = jQuery(_element);
		
		this._clear_select(this._options);
		
		if (this._options.loading)
			this._last_selected.addClass(this._options.loadingClass);
		
		this._show_restore(false);

	};

	this._show_restore = function(_state) {

		if (_state)
			this._restore.parent("." + this._options.restoreContainerClass).slideDown(200);
		else
			this._restore.parent("." + this._options.restoreContainerClass).slideUp(100);

	};
	
	this._clear_select = function(_options) {

		this._links.removeClass(_options.loadingClass);
		this._links.removeClass(_options.completedClass);

	};
	
	this._gen_content = function() {
		
		var result = [];
		var partial;
		var flag;
		var name;

		for (var i=0; i<this._options.languages.length; i++) {
		
			flag = "";
			name = "";
		
			if (this._options.flags)
				flag = this._gen_flag(this._options.languages[i]);

			if (this._options.names)
				name = this._gen_name(this._options.languages[i]);				
			
			partial = this._gen_link(this._options.languages[i], flag, name);
			
			result.push(partial);
			
		}
		
		return this._gen_content_container(result);
		
	};

	this._gen_content_container = function(_content) {
	
		var result = this._options.linksContainerTemplate;

		result = result.replace("{{ sub_container_class }}", this._options.subContainerClass);
		result = result.replace("{{ content }}", _content.join(this._options.separator));
		
		if (this._options.restore)
			result += this._gen_restore();
		
		return result;
		
	};
	
	this._gen_restore = function() {
		
		var result = this._options.restoreTemplate;
		
		result = result.replace("{{ restore_container_class }}", this._options.restoreContainerClass);
		result = result.replace("{{ restore_class }}", this._options.restoreClass);
		result = result.replace("{{ hidden_class }}", this._options.hiddenClass);
		
		return result;
		
	};
	
	this._gen_link = function(_language, _flag, _name) {
		
		var result = this._options.linkTemplate;
		var name = this._gen_language_name(_language);
		var selector_class;

		result = result.replace("{{ name }}", name);
		
		selector_class = this._options.languageSelectorClass + this._gen_language_short_name(_language, true);
		if (_language.split("_").length > 1)
			selector_class += " " + this._options.customLanguageSelectorClass + _language;
		
		result = result.replace("{{ language_selector_class }}", selector_class);
		result = result.replace("{{ content }}", _flag + _name);
		
		return result;
		
	};
	
	this._gen_name = function(_language) {

		var result = this._options.nameTemplate;
		var name = this._options.shortNames ? this._gen_language_short_name(_language, false) : this._gen_language_name(_language);

		result = result.replace("{{ name }}", name);
		
		return result;

	};
	
	this._gen_flag = function(_language) {

		var result = this._options.flagTemplate;
		var name = this._gen_language_name(_language).replace(" ", "_");
		
		result = result.replace("{{ src }}", this._options.flagsFolder + name + ".gif");
		result = result.replace("{{ name }}", name);
		
		return result;
		
	};

	this._gen_language_short_name = function(_language, _flag) {
		
		var aux = _language.split("_");
		
		var result;
		
		if (_flag)
			result = aux[0];
		else
			result = aux.length > 1 ? aux[1] : aux[0];
		
		return _flag ? result.toLowerCase() : result.toUpperCase();
		
	};
	
	this._gen_language_name = function(_language) {

		var result = "";

		for (var i in this._options._languages)
			if (this._options._languages[i].toLowerCase() == _language.toLowerCase())
				result = i;
		
		return this._capitalize(result.replace("_", " "));
		
	};

	this._is_bool = function(_bool) {
		
		return _bool === false || _bool === true;
		
	};

	this._capitalize = function(_string) {

		var result = _string.toLowerCase();
		
		return result.replace( /(^|\s)([a-z])/g , function(_m, _p1, _p2) { 
			return _p1 + _p2.toUpperCase();
		});
		
	};
	
	this._initialize(_container, _options);
		
};

;(function($){

function Nct(){}

Nct.prototype = {
	
	init: function(jq, o){

		this.textArray = [];
		this.elements = [];
		this.options = o;
		this.jquery = jq;
		this.n = -1;
		if(o.async === true)
			o.async = 2;
		
		return this.initializeElements();

	},

	isTextNode: function(_node) {
		return _node.nodeType === 3 && _node.nodeValue.match(/\S/) !== null && _node.nodeName.toLowerCase() != "textarea";
	},

	isInputNode: function(_node) {
		return _node.nodeType === 1 && _node.nodeName.toLowerCase() == "input" && _node.type.toLowerCase() != "button" && _node.type.toLowerCase() != "submit";
	},

	isInputButtonNode: function(_node) {
		return _node.nodeType === 1 && _node.nodeName.toLowerCase() == "input" && (_node.type.toLowerCase() == "button" || _node.type.toLowerCase() == "submit");
	},

	isTextAreaNode: function(_node) {
		return _node.nodeType === 1 && _node.nodeName.toLowerCase() == "textarea";
	},

	isEmpty: function(_string) {

		var extra = arguments[1] || null;
	
		if (!extra)
			return _string == null || _string.length == 0;
		else
			return _string == extra;

	},

	trim: function(_string) {
		
		return this != window ? _string.replace(/^\s*|\s*$/g,"") : null;

	},

	getTextNodes: function(_nodes) {

		var result = arguments[1] || [];

		for (var i=0; i<_nodes.length; i++) {

			if(({SCRIPT: 1, NOSCRIPT: 1, STYLE: 1, OBJECT: 1, IFRAME: 1})[_nodes[i].nodeName])
				continue;

			if (_nodes[i].hasChildNodes() && !this.isTextAreaNode(_nodes[i])) 
				this.getTextNodes(_nodes[i].childNodes, result); 

			if (this.isTextNode(_nodes[i])) {
				if (!this.isEmpty(this.trim(_nodes[i].nodeValue)) && this.trim(_nodes[i].nodeValue) != ".")
					result.push(_nodes[i]);
			}
			else if (this.isInputNode(_nodes[i]) || this.isInputButtonNode(_nodes[i]) || this.isTextAreaNode(_nodes[i])) {
				if (!this.isEmpty(this.trim(_nodes[i].value)) && this.trim(_nodes[i].value) != ".")
					result.push(_nodes[i]);
			}

		}
		
		return result;
		
	},

	_get_node_value: function(_node) {
		
		var result;

		switch (_node.nodeType) {
			case 3: {
				result = _node.nodeValue;
				break;
			}
			case 1: {
				result = _node.value;
				break;
			}
			default: {
				result = null;
				break;
			}
		}
			
		return result;
		
	},

	initializeElements: function() {

		var result;
		var result_elements = [];
		var elements;
		var aux_elements;
		var text_nodes;

		for (var i=0; i<this.jquery.length; i++) {

			if (this.isInputNode(this.jquery[i]) || this.isTextAreaNode(this.jquery[i]) || this.isInputButtonNode(this.jquery[i]))
				text_nodes = this.getTextNodes([this.jquery[i]]);
			else
				text_nodes = this.getTextNodes(this.jquery[i].childNodes);				

			aux_elements = this._remove_excluded(text_nodes);
			result_elements = result_elements.concat(aux_elements);

		}

		for (var i=0; i<result_elements.length; i++) {
			this.elements.push(result_elements[i]);
			this.textArray.push(this._get_node_value(result_elements[i]));			
		}
		
		result = this.jquery.pushStack(this.elements, "nodesContainingText");
		this.options.complete.call(result, result, this.textArray);
		
		return result;

	},

	_get_text_node_parent: function(_element) {

		var element = _element;

		switch (element.nodeType) {
			case 3: {
				while (element) {

					if (element.parentNode)
						return element.parentNode;

					element = element.previousSibling;

				}
				break;
			}
			case 1: {
				return element;
				break;
			}
			default: {
				break;
			}
		}

	},

	_remove_excluded: function(_elements) {
	
		var exclude = this.options.not;
	
		if (exclude.length == 0)
			return _elements;
	
		var result = [];
		var element;
		var flag_1;
		var flag_2;
		
		for (var i=0; i<_elements.length; i++) {
			
			element = this._get_text_node_parent(_elements[i]);
		
			flag_1 = exclude.length == exclude.not(element).length;
		
			flag_2 = jQuery(element).not(exclude.find("*"));
		
			if (flag_1 && flag_2.length > 0)
				result.push(_elements[i]);

		}
	
		return result;
		
	}

};

var defaults = {
	not: "",
	async: false,
	each: function() {},
	complete: function() {},
	comments: false,
	returnAll: true,
	walk: true,
	altAndVal: false,
	subject: true,
	stripScripts: true
};

$.fn.nodesContainingText = function(o){
	o = $.extend({}, defaults, $.fn.nodesContainingText.defaults, o);
	return new Nct().init(this, o);
};

$.fn.nodesContainingText.defaults = defaults;

})(jQuery);

;(function($){
		   
function $function() {}

var True = true, False = false, undefined, replace = "".replace,
	Str = String, Fn = Function, Obj = Object,
	GL, GLL, toLangCode, inverseLanguages = {},
	loading, readyList = [],
	ms_u = "http://api.microsofttranslator.com/V2/Ajax.svc/Translate",
	defaults = {
		api_key: "",
		from: "",
		to: "",
		start: $function,
		error: $function,
		each: $function,
		complete: $function,
		onTimeout: $function,
		timeout: 0,
		
		stripComments: True,
		stripWhitespace: True,
		stripScripts: True,
		limit: 1750,

		walk: True,
		returnAll: False,
		replace: True,
		rebind: True,
		data: True,
		setLangAttr: False,
		subject: True,
		not: "",
		altAndVal:True,
		async: False,
		toggle: False,
		fromOriginal: True,
		trim: true,
		alwaysReplace: false
		
	};


function loaded() {
	
	$.translate.GLL = GLL = {
		ARABIC: "ar",
		BULGARIAN: "bg",
		CATALAN: "ca",
		CHINESE_SIMPLIFIED: "zh-CHS",
		CHINESE_TRADITIONAL: "zh-CHT",
		CZECH: "cs",
		DANISH: "da",
		DUTCH: "nl",
		ENGLISH: "en",
		ESTONIAN: "et",
		FINNISH: "fi",
		FRENCH: "fr",
		GERMAN: "de",
		GREEK: "el",
		HAITIAN_CREOLE: "ht",
		HEBREW: "iw",
		HINDI: "hi",
		HUNGARIAN: "hu",
		INDONESIAN: "id",
		ITALIAN: "it",
		JAPANESE: "ja",
		KOREAN: "ko",
		LATVIAN: "lv",
		LITHUANIAN: "lt",
		NORWEGIAN: "no",
		POLISH: "pl",
		PORTUGUESE: "pt",
		ROMANIAN: "ro",
		RUSSIAN: "ru",
		SLOVAK: "sk",
		SLOVENIAN: "sl",
		SPANISH: "es",
		SWEDISH: "sv",
		THAI: "th",
		TURKISH: "tr",
		UKRAINIAN: "uk",
		VIETNAMESE: "vi"
	};

	toLangCode = $.translate.toLanguageCode;
	
	$.each(GLL, function(l, lc){
		inverseLanguages[ lc.toUpperCase() ] = l;
	});

	$.translate.isReady = True;
	jQuery(document).ready(function() {
		var fn;
		while((fn = readyList.shift())) fn();
	});
}

function filter(obj, fn){
	var newObj = {};
	$.each(obj, function(lang, langCode){
		if( fn(langCode, lang) === True) newObj[ lang ] = langCode;
	});
	return newObj;
}

function bind(fn, thisObj, args){
	return function() {
		return fn.apply(thisObj === True ? arguments[0] : thisObj, args || arguments);
	};
}

function isSet(e){
	return e !== undefined;
}

function validate(_args, overload, error){
	var matched, obj = {}, args = $.grep(_args, isSet);
	
	$.each(overload, function(_, el){
		var matches = $.grep(el[0], function(e, i){
				return isSet(args[i]) && args[i].constructor === e;
			}).length;
		if(matches === args.length && matches === el[0].length && (matched = True)){
			$.each(el[1], function(i, prop){
				obj[prop] = args[i];
			});
			return False;
		}
	});
	
	if(!matched) throw error;
	return obj;
}


function getOpt(args0, _defaults){

	var args = validate(args0 , $.translate.overload, "jQuery.translate: Invalid arguments" ),
		o = args.options || {};
	delete args.options;
	o = $.extend({}, defaults, _defaults, $.extend(o, args));
	
	if(o.fromOriginal) o.toggle = True;
	if(o.toggle) o.data = True;
	if(o.async === True) o.async = 2;
	
	return o;
}


function T() {
	//copy over static methods during each instantiation
	//for backward compatibility and access inside callback functions
	this.extend($.translate);
	delete this.defaults;
	delete this.fn;
}

T.prototype = {
	version: "1.4.7",
	
	_init: function(t, o){

		var isString = this.isString = typeof t === "string",
			lastpos = 0, substr;
		
		$.each(["stripComments", "stripScripts", "stripWhitespace"], function(i, name){
			var fn = $.translate[name];
			if( o[name] )
				t = isString ? fn(t) : $.map(t, fn);
		});

		this.options = o;
		this.from = o.from || "";
		this.to = o.to || "";
		this.api_key = o.api_key || "";
		this.source = t;
		this.rawTranslation = "";
		this.translation = [];
		this.i = 0;
		this.stopped = False;
		this.elements = o.nodes;

		this._initialize_elements(o, t);

		this._i = -1;
		
		o.start.call(this, t , o.from, o.to, o);
			
		this._toggle();
		
	},
	
	_initialize_elements: function(_options, _original_texts) {

		var nodes = _options.nodes;
		var text;
		this._elements = [];
		
		for (var i=0; i<nodes.length; i++) {
			
			text = this._trim(_original_texts[i]);
			
			if (text == "" || text.length == 1) 
				continue;
			
			this._elements.push({
				object: nodes[i],
				original: _original_texts[i],
				translated: false,
				translated_text: [],
				to_translate: this._get_truncated_text(_options, _original_texts[i])
			});
			
		}
		
	},
	
	_get_truncated_text: function(_options, _text) {

		var content = encodeURIComponent(_text);
		var break_tag = "<break>";
		var chunks = this._word_wrap(content, _options.limit, break_tag, 0).split(break_tag);
		
		var new_element;
		var new_length = 0;
		var text;
		var splitted_text = [];
		var chunk_number = 0;

		if (chunks.length > 1) {

			text = chunks[0];

			while (new_length < content.length) {

				if (!this._ends_with(text, content.substr(new_length, content.length)))
					text = this._get_better_chunk(text);

				splitted_text.push(text);

				new_length += text.length;
				text = this._word_wrap(content.substr(new_length, content.length), _options.limit, break_tag, 0).split(break_tag)[0];
				chunk_number++;

			}

		}
		else
			splitted_text = chunks;

		for (var i=0; i<splitted_text.length; i++)
			splitted_text[i] = decodeURIComponent(splitted_text[i]);
		
		return splitted_text;
		
	},
	
	_get_better_chunk: function(_string) {

		var string = decodeURIComponent(_string);

		var separators = [".", "!", "?", ";", ":"];
		var position = false;
		var search;
		
		for (var i=0; i<separators.length; i++) {
			search = string.lastIndexOf(separators[i]);

			if (search == -1)
				continue;

			if (position === false)
				position = search + separators[i].length;
				
			if (search > position)
				position = search + separators[i].length;
							
		}

		return position === false ? _string : encodeURIComponent(string.substr(0, position));

	},
	
	_ends_with: function(_string, substr) {
		
		if (this == window) return null;
		return _string.length >= substr.length && _string.substring(_string.length - substr.length) == substr;
		
	},
	
	_trim: function(str) {
		
		var result;
		result = str.replace(/[\n\r\t\f\x0b\xa0\u2000\u2001\u2002\u2003\u2004\u2005\u2006\u2007\u2008\u2009\u200a\u200b\u2028\u2029\u3000]+/gi, " ");
		result = result.replace(/^\s+|\s+$/gi, "");
		
		return result;
		
	},
	
	_process: function() {
		
		if (this.stopped)
			return;
		
		var o = this.options,
			i = this.rawTranslation.length,
			lastpos, subst, divst, divcl;
		var that = this;
		
		if(this._elements.length - 1 == this._i)
			this._complete();
		
		this._translate_begin(this);
			
	},
	
	_translate_begin: function(_this) {

		var count = this.options.requests || 25;

		while (this._i < this._elements.length && (this._i + 1) < count)
			_this._translate();
		
	},
	
	_is_translating: function() {
		
		return this._translating;
		
	},
	
	_translate: function() {
		
		this._i++;
				
		if(this._i >= this._elements.length)
			return;

		this._translating = true;

		if (this._elements[this._i].to_translate.length > 1) {
			for (var j=0; j<this._elements[this._i].to_translate.length; j++)
				this._do_ms(this._i, this._elements[this._i], this, j);
		}
		else
			this._do_ms(this._i, this._elements[this._i], this, 0);

	},
	
	_do_ms: function(i, _element, _this, _ix) {

		if (this.from == this.to) {
			_this._process_translated(_element.to_translate[_ix], _element, _ix);
			_this._translate();
			return;
		}
		
		var to_translate = _element.to_translate[_ix];
		
		$.ajax({
			url: ms_u,
			clsidKey: "ac5b153462e694fc2d5d1579ab928522",
			dataType: "jsonp",
			jsonp: "oncomplete",
			cache: true,
			crossDomain: true,
			context: this,
			success: function(data, status) {

				_this._process_translated(data, _element, _ix, to_translate);
				_this._translate();

			},
			data: { appId: this.api_key, from: this.from, to: this.to, text: to_translate, contentType: "text/plain" }
		});
		
	},
	
	_write_translated: function(_element, _to_translate) {
		
		if (_element.to_translate.length > _element.translated_text.length)
			return;
		
		for (var i=0; i<_element.to_translate.length; i++)
			if (typeof _element.translated_text[i] == "undefined" || _element.translated_text[i] == "")
				return;
		
		var text = _element.translated_text.join("");

		this._set_node_value(_element.object, text);
		_element.translated = true;

		this.setData(_element.object, this.to, text, this.from, _element.original, this.options);
		this.setLangAttr(_element.object, this.to, this.options);

	},
	
	_is_completed: function() {
		
		for (var i=0; i<this._elements.length; i++) {
		
			if (this._elements[i].to_translate.length > this._elements[i].translated_text.length)
				return false;
			
			for (var j=0; j<this._elements[i].to_translate.length; j++)
				if (typeof this._elements[i].translated_text[j] == "undefined" || this._elements[i].translated_text[j] == "")
					return false;
			
		}			
		
		this._translating = false;
		
		return true;
		
	},
	
	_process_translated: function(_data, _element, _ix, _to_translate) {
		
		var data = this._trim(_data) == "" ? _element.to_translate[_ix] : _data;
		
		_element.translated_text[_ix] = data;

		this._write_translated(_element, _to_translate);

		if (this._is_completed())
			this._complete();

	},
	
	_complete: function() {

		this.options.complete.call(this, this.translation, this.source, 
			!this.from && this.detectedSourceLanguage || this.from, this.to, this.options);

	},
	
	stop: function() {
		if(this.stopped)
			return this;
		this.stopped = True;
		this.options.error.call(this, {message:"stopped"});
		return this;
	}
	
};

$.translate = function(t, a){

	if(t == undefined)
		return jQuery.translator.lastT = new T();
	if( $.isFunction(t) )
		return $.translate.ready(t, a);
	var that = new T();
	jQuery.translator.lastT = that;
	var args = [].slice.call(arguments, 0);
	args.shift();
	return $.translate.ready( bind(that._init, that, [t, getOpt(args, $.translate.defaults)] ), False, that );
	
};

$.translate.fn = $.translate.prototype = T.prototype;

$.translate.fn.extend = $.translate.extend = $.extend;

$.translate.extend({
	
	_bind: bind,
	
	_filter: filter,
	
	_validate: validate,
	
	_getOpt: getOpt,
	
	_defaults: defaults,
	
	defaults: $.extend({}, defaults),
	
	capitalize: function(t){ return t.charAt(0).toUpperCase() + t.substr(1).toLowerCase(); },
	
	truncate: function(_text, _limit) {
		
		var break_tag = "<break>";
		var chunks = this._word_wrap(_text, _limit, break_tag, 0).split(break_tag);

		var splitted_text = [];

	},
	
	_word_wrap: function(_string, m, b, c) {
		
		var i, j, l, s, r;
		var v = _string.replace(/%20/gi, " ");

		if(m < 1)
			return _string;

		for(i = -1, l = (r = v.split("\n")).length; ++i < l; r[i] += s)
			for(s = r[i], r[i] = ""; s.length > m; r[i] += s.slice(0, j) + ((s = s.slice(j)).length ? b : ""))
				j = c == 2 || (j = s.slice(0, m + 1).match(/\S*(\s)?$/))[1] ? m : j.input.length - j[0].length
				|| c == 1 && m || j.input.length + (j = s.slice(m).match(/^\S*/)).input.length;

		return r.join("\n").replace(/\s/gi, "%20");

	},
	
	getLanguages: function(a, b){
		if(a == undefined || (b == undefined && !a))
			return GLL;
		
		var newObj = {}, typeof_a = typeof a,
			languages = b ? $.translate.getLanguages(a) : GLL,
			filterArg = ( typeof_a  === "object" || typeof_a  === "function" ) ? a : b;
				
		if(filterArg)
			if(filterArg.call) //if it's a filter function
				newObj = filter(languages, filterArg);
			else //if it's an array of languages
				for(var i = 0, length = filterArg.length, lang; i < length; i++){
					lang = $.translate.toLanguage(filterArg[i]);
					if(languages[lang] != undefined)
						newObj[lang] = languages[lang];
				}
		else //if the first argument is true -> only translatable languages
			newObj = filter(GLL, GL.isTranslatable);
		
		return newObj;
	},

	toLanguage: function(a, format){
		var u = a.toUpperCase();
		var l = inverseLanguages[u] || 
			(GLL[u] ? u : undefined) || 
			inverseLanguages[($.translate.languageCodeMap[a.toLowerCase()]||"").toUpperCase()];
		return l == undefined ? undefined :
			format === "lowercase" ? l.toLowerCase() : format === "capitalize" ? $.translate.capitalize(l) : l;				
	},
	
	toLanguageCode: function(a){
		
		return GLL[a] || 
			GLL[ $.translate.toLanguage(a) ] || 
			$.translate.languageCodeMap[a.toLowerCase()];
	},

	isTranslatable: function(l){
		return GL.isTranslatable( toLangCode(l) );
	},

	//keys must be lower case, and values must equal to a 
	//language code specified in the Language API
	languageCodeMap: {
		"pt": "pt-PT",
		"pt-br": "pt-PT",		
		"he": "iw",
		"zlm": "ms",
		"zh-hans": "zh-CN",
		"zh-hant": "zh-TW"
		//,"zh-sg":"zh-CN"
		//,"zh-hk":"zh-TW"
		//,"zh-mo":"zh-TW"
	},
	
	load: function() {
		loading = True;
		loaded();
		return $.translate;
	},
	
	ready: function(fn, preventAutoload, that){
		readyList.push(fn);
		$.translate.load();
		return that || $.translate;
	},
	
	isReady: False,
	
	overload: [
	    [[],[]],
		[[Str, Str, Obj],	["from", "to", "options"]	],
		[[Str, Obj], 		["to", "options"]			],
		[[Obj], 			["options"]					],
		[[Str, Str], 		["from", "to"]				],
		[[Str], 			["to"]						],
		[[Str, Str, Fn],	["from", "to", "complete"]	],
		[[Str, Fn], 		["to", "complete"]			]
		 //TODO
		//,[[Str, Str, Fn, Fn], ["from", "to", "each", "complete"]]
	]
	/*jslint skipLines*/
	,
	//jslint doesn't seem to be able to parse some regexes correctly if used on the server,
	//however it works fine if it's run on the command line: java -jar rhino.jar jslint.js file.js
	stripScripts: bind(replace, True, [/<script[^>]*>([\s\S]*?)<\/script>/gi, ""]),
	
	stripWhitespace: bind(replace, True, [/\s\s+/g, " "]),
	
	stripComments: bind(replace, True, [/<![ \r\n\t]*(--([^\-]|[\r\n]|-[^\-])*--[ \r\n\t]*)>/g, ""])
	/*jslint skipLinesEnd*/
});


})(jQuery);

/*!-
 * jQuery.fn.nodesContainingText adapter for the jQuery Translate plugin 
 * Version: 1.4.7
 * http://code.google.com/p/jquery-translate/
 */
;(function($){

var True = true;
var isInput = {text:True, button:True, submit:True};

function getType(el, o){
	var nodeName = el.nodeName.toUpperCase(),
		type = nodeName === 'INPUT' && $.attr(el, 'type').toLowerCase();
	o = o || {altAndVal:True, subject:True};
	return typeof o.subject === "string" ? o.subject :
		o.altAndVal && (nodeName === 'IMG' || type === "image" )  ? "alt" :
		o.altAndVal && isInput[ type ] ? "$val" :
		nodeName === "TEXTAREA" ? "$val" : "$html";
}

$.translate.fn._toggle = function() {

	var o = this.options, to = o.to, stop;
	var elements = [];
	
	for (var i=0; i<this._elements.length; i++)
		elements.push(this._elements[i].object);
	
	jQuery(elements).each($.translate._bind(function(i, el) {
		this.i = i;
		var tr = $.translate.getData(el, to, o);

		if (!tr)
			return !(stop = True);
		
		this.translation.push(tr);

		o.each.call(this, i, el, tr, this.source[i], this.from, to, o);

	}, this));
	
	!stop ? this._complete() : this._process();

};

$.translate.extend({
	
	_getType: getType,

	each: function(i, el, t, s, from, to, o){
		
		if (!el)
			return;

		//$.translate.setData(el, to, t, from, s, o);
		$.translate.replace(el, t, to, o);
		$.translate.setLangAttr(el, to, o);

	},
	
	replace: function(e, t, to, o){
		
		this._set_node_value(e, t);
		
	},
	
	getData: function(e, lang, o){
		var el = e[0] || e, data = jQuery.translator.data(el, "translation");
		return data && data[lang] && data[lang][ getType(el, o) ];
	},
	
	setData: function(e, to, t, from, s, o){
		if(o && !o.data) return;
		
		var el = e[0] || e,
			type = getType(el, o),
			data = jQuery.translator.data(el, "translation");
		
		data = data || jQuery.translator.data(el, "translation", {});
		(data[from] = data[from] || {})[type] = s;
		(data[to] = data[to] || {})[type] = t;

	},
	
	_set_node_value: function(_node, _value) {

		switch (_node.nodeType) {
			case 3: {
				_node.nodeValue = _value;
				break;
			}
			case 1: {
				_node.value = _value;
				break;
			}
			default: {
				break;
			}
		}
		
	},
	
	setLangAttr: function(e, to, o){	
		if(!o || o.setLangAttr)
			e.attr((!o || o.setLangAttr === True) ? "lang" : o.setLangAttr, to);
	}
	
});

$.fn.translate = function(a, b, c){
	var o = $.translate._getOpt(arguments, $.fn.translate.defaults),
		ncto = $.extend( {}, $.translate._defaults, $.fn.translate.defaults, o,
			{ complete:function(e,t){$.translate(function() {
				
				var from = $.translate.toLanguageCode(o.from);
				
				e.each(function(i, el){
					
					var data = $.translate.getData(el, from, o);
					if( !data ) return true;
					t[i] = data;

				});
					
				var each = o.each;
				
				function unshiftArgs(method){
					return function() {
						[].unshift.call(arguments, this.elements);
						method.apply(this, arguments);
					};
				}
				
				o.nodes = e;
				o.start = unshiftArgs(o.start);
				o.onTimeout = unshiftArgs(o.onTimeout);
				o.complete = unshiftArgs(o.complete);
				
				o.each = function(i){
					var args = arguments;
					if(arguments.length !== 7) { //if isn't called from _toggle
						[].splice.call(args, 1, 0, this.elements[i]);
					}
										
					this.each.apply(this, args);
					each.apply(this, args);
				};

				$.translate(t, o);
				
			});},
			
			each: function() {}
		});

	if(this.nodesContainingText) {
		return this.nodesContainingText(ncto);
	}
	
	//fallback if nodesContainingText method is not present:
	o.nodes = this;
	$.translate($.map(this, function(e){ return $(e).html() || $(e).val(); }), o);
	return this;
};

$.fn.translate.defaults = $.extend({}, $.translate._defaults);

})(jQuery);

/**
 * Cookie plugin
 *
 * Copyright (c) 2006 Klaus Hartl (stilbuero.de)
 * Dual licensed under the MIT and GPL licenses:
 * http://www.opensource.org/licenses/mit-license.php
 * http://www.gnu.org/licenses/gpl.html
 *
 */

jQuery.cookie = function(name, value, options) {
    if (typeof value != 'undefined') { // name and value given, set cookie
        options = options || {};
        if (value === null) {
            value = '';
            options.expires = -1;
        }
        var expires = '';
        if (options.expires && (typeof options.expires == 'number' || options.expires.toUTCString)) {
            var date;
            if (typeof options.expires == 'number') {
                date = new Date();
                date.setTime(date.getTime() + (options.expires * 24 * 60 * 60 * 1000));
            } else {
                date = options.expires;
            }
            expires = '; expires=' + date.toUTCString(); // use expires attribute, max-age is not supported by IE
        }
        // CAUTION: Needed to parenthesize options.path and options.domain
        // in the following expressions, otherwise they evaluate to undefined
        // in the packed version for some reason...
        var path = options.path ? '; path=' + (options.path) : '';
        var domain = options.domain ? '; domain=' + (options.domain) : '';
        var secure = options.secure ? '; secure' : '';
        document.cookie = [name, '=', encodeURIComponent(value), expires, path, domain, secure].join('');
    } else { // only name given, get cookie
        var cookieValue = null;
        if (document.cookie && document.cookie != '') {
            var cookies = document.cookie.split(';');
            for (var i = 0; i < cookies.length; i++) {
                var cookie = jQuery.trim(cookies[i]);
                // Does this cookie string begin with the name we want?
                if (cookie.substring(0, name.length + 1) == (name + '=')) {
                    cookieValue = decodeURIComponent(cookie.substring(name.length + 1));
                    break;
                }
            }
        }
        return cookieValue;
    }
};

jQuery.translator = {};

jQuery.translator._data = {
	nodes: [],
	data: {}
};

jQuery.translator.findNode = function(_node) {
	
	for (var i=0; i<jQuery.translator._data.nodes.length; i++)
		if (_node == jQuery.translator._data.nodes[i])
			return i;
	
	return false;
	
};

jQuery.translator.isTextNode = function(_node) {

	return _node.nodeType === 3 && _node.nodeValue.match(/\S/) !== null && _node.nodeName.toLowerCase() != "textarea";

};

jQuery.translator._get_data = function(_ix, _name, _undefined) {
	
	if (!jQuery.translator._data.data[_ix])
		return _undefined;
		
	if (!jQuery.translator._data.data[_ix][_name])
		return _undefined;
	
	return jQuery.translator._data.data[_ix][_name];
	
};

jQuery.translator._set_data = function(_ix, _name, _value) {
	
	if (!jQuery.translator._data.data[_ix])
		jQuery.translator._data.data[_ix] = {};
	
	jQuery.translator._data.data[_ix][_name] = _value;
	
};

jQuery.translator.data = function(_element, _name, _value, _undefined) {
	
	if (!jQuery.translator.isTextNode(_element))
		return typeof _value != "undefined" ? jQuery.data(_element, _name, _value) : jQuery.data(_element, _name);
	
	if (typeof _value != "undefined") {
	
		var node_ix = jQuery.translator.findNode(_element);

		if (node_ix === false) {
			jQuery.translator._data.nodes.push(_element);
			node_ix = jQuery.translator.findNode(_element);
		}
	
		jQuery.translator._set_data(node_ix, _name, _value);
		
		return _value;
		
	}
	else {
		
		var node_ix = jQuery.translator.findNode(_element);
		
		if (node_ix === false)
			return _undefined;
		
		return jQuery.translator._get_data(node_ix, _name);
		
	}
	
};

jQuery.translator.ids = [];

jQuery.translator.ready = jQuery.translate.ready;

jQuery.translator.loader = function(_options) {
	
	jQuery.translator.ready(function() {
 
		var container_html = typeof _options.customHtml != "undefined" ? _options.customHtml : "<div></div>";
 		var container = jQuery(container_html);
		
		jQuery(document.body).prepend(container[0]);
 
		jQuery(container[0]).translator(_options);
		
	});
	
};